function sparkline(ctx, data, color, x, y, width, height, xmin, xmax, ymin, ymax) {
	this.ctx = ctx;
	this.data = data;
	this.color = color;
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	
	this.xmin = xmin;
	this.xmax = xmax;
	this.ymin = ymin;
	this.ymax = ymax;
	
	this.__construct();
}

sparkline.prototype = {
	__construct : function() {
	},
	draw : function() {
		var stats = new Statistic(this.data);
		var points = [];
		var offset = stats.min;
		var range = 0;
		if(stats.max - stats.min != 0) {
			range = this.height / (stats.max - stats.min);
		}
		
		var distance = this.width / (this.data.length-1);
		this.ctx.beginPath();
		
		for(var i = 0; i < this.data.length; i++) {
			var x = this.x + i * distance;
			var y = this.y + this.height - (this.data[i] - offset) * range;
			if(i == 0) {
				this.ctx.moveTo(x, y);
			} else {
				this.ctx.lineTo(x, y);
			}
		}
		this.ctx.stroke();
		
	}
};

function time_sparkline(ctx, data, color, x, y, width, height) {
	this.ctx = ctx;
	this.data = data;
	this.color = color;
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	
	this.__construct();
}

time_sparkline.prototype = {
	__construct : function() {
	},
	draw : function(clear) {
		var cnt = 0;
		
		if(clear === true || clear === undefined) {
			this.ctx.clearRect(this.x, this.y, this.width, this.height);
		}
		
		if(this.data.length <= 1) { return; }
		
		this.data.sort(function(a,b) { return a.t - b.t});

		var xmin = this.data[0].t;
		var xmax = this.data[this.data.length-1].t;
		var ymin = this.data[0].v;
		var ymax = this.data[0].v;
		
		
		for(var i = 0; i < this.data.length; i++) {
			if(ymin > this.data[i].v) { ymin = this.data[i].v; }
			if(ymax < this.data[i].v) { ymax = this.data[i].v; }
		}

		var yoffset = ymin;
		var yrange = 0;
		if(ymax - ymin != 0) {
			yrange = (ymax - ymin);
		}
		
		var xoffset = xmin;
		var xrange = 0;
		if(xmax - xmin != 0) {
			xrange = (xmax - xmin);
		}
		
		if(xrange == 0 || isNaN(xrange) || isNaN(yrange) || yrange == 0) return;
		
		
		
		this.ctx.beginPath();
		
		for(var i = 0; i < this.data.length; i++) {
			
			var x = this.x + this.width * (this.data[i].t - xoffset)/xrange;
			var y = this.y + this.height - (this.data[i].v - yoffset)/yrange * this.height;
			if(i == 0) {
				this.ctx.moveTo(x, y);
			} else {
				this.ctx.lineTo(x, y);
			}
		}
		this.ctx.stroke();
	},
	
	add : function(a) {
		for(var i = 0; i < this.data.length; i++) {
			if(this.data[i].t == a.t) {
				this.data[i].v = a.v;
				return;
			}
		}
		this.data[this.data.length] = {"t" : a.t, "v" : a.v};
	},
};

