function NiceBuffer(canvas, width, height, tmpmin, tmpmax, temps) {
	this.ctx = canvas.getContext('2d');
	this.width = width;
	this.height = height;
	this.tmpmin = tmpmin;
	this.tmpmax = tmpmax;
	if(temps !== undefined && temps !== null) {
		this.redraw(temps);
	}
}

NiceBuffer.prototype = {
	getCol : function(x) {
		var cols = [[0x02,0xAF,0xEE],[0xBE,0x01,0x02]];
		
		upperidx = Math.ceil((cols.length - 1) * x);
		
		if(upperidx == 0) { upperidx = 1};
		uppercol = cols[upperidx];
		lowercol = cols[upperidx - 1];
		
		var part = x * (cols.length - 1) - (upperidx - 1);
	
		return [
				Math.round(lowercol[0] + (uppercol[0] - lowercol[0]) * part),
				Math.round(lowercol[1] + (uppercol[1] - lowercol[1]) * part),
				Math.round(lowercol[2] + (uppercol[2] - lowercol[2]) * part)
			];
	},
	
	cssrgb : function(r,g,b) {
		return "rgb(" + r + ", " + g + ", " + b + ")";
	},
	
	cssrgbarr : function(col) {
		return "rgb(" + col[0] + ", " + col[1] + ", " + col[2] + ")";
	},



	redraw : function(temps) {
		//var tmpmax = 60;
		//var tmpmin = 25;
		var stops = [0.2, 0.65, 0.9];
		
		this.ctx.clearRect(0,0, this.width + 100, this.height + 100); //whatever
		
		var lineargradient = this.ctx.createLinearGradient(0,0,0,this.height);  
		
		for(var i = 0; i < Math.min(temps.length, stops.length); i++) {
			var tmp = temps[i];
			if(tmp > this.tmpmax) {
				tmp = this.tmpmax;
			} else if(temps[i] < this.tmpmin) {
				tmp = this.tmpmin;
			}
			tmp = (tmp - this.tmpmin) / (this.tmpmax - this.tmpmin);
			
			lineargradient.addColorStop(stops[i], this.cssrgbarr(this.getCol(tmp))); 
			
		}
		
		this.ctx.fillStyle = lineargradient;
		
		this.ctx.beginPath();  
		
		var x = 1; var y = 0;
		var w = this.width;
		var h = this.height;
		var caph = 30;
		var capxoff = 25
		
		this.ctx.moveTo(x,y+caph);
		
		this.ctx.bezierCurveTo(x + capxoff, y, x + w - capxoff, y, x + w, y + caph);
		this.ctx.lineTo(x + w, y + h);
		this.ctx.bezierCurveTo(x + w - capxoff, y+h + caph, x + capxoff, y + h + caph, x, y + h);
		this.ctx.lineTo(x, y + caph);
		this.ctx.closePath();
		
		this.ctx.fill();
		
		this.ctx.stroke();
	}
}