﻿/**
 * @author: Christof Rueß, http://hobbyelektronik.org
 * @license: http://creativecommons.org/licenses/by-nc-sa/3.0/
 * Feel free to share and remix this 
 * but:
 * - leave this comment in the code
 * - don't use this code for commercial purposes
 * - when you alter this code: c'mon, share it like I did!
 *
 * see: http://www.hobbyelektronik.org/wiki/index.php?title=Commercial_Use
 */

function getWindowSize() {
	var retval = { "height" : 0, "width" : 0 };
	if(self.innerHeight) {
		retval.width = self.innerWidth;
		retval.height = self.innerHeight;
	} else if(document.documentElement && document.documentElement.clientHeight) {
		retval.width = document.documentElement.clientWidth;
		retval.height = document.documentElement.clientHeight;
	} else if(document.body) {
		retval.width = document.body.clientWidth;
		retval.height = document.body.clientHeight;
	}
	return retval;
}

function getPageSize() {
	var retval = { "height" : 0, "width" : 0 };
	if(self.innerWidth) {
		retval.width = self.innerWidth;
		retval.height = self.innerHeight;
	} else if(document.documentElement) {
		retval.width = document.documentElement.clientWidth;
		retval.height = document.documentElement.clientHeight;
	} else {
		retval.width = document.body.offsetWidth;
		retval.height = document.body.offsetHeight;
	}
	
	return retval;
}

function getScrollOffset() {
	var retval = { "x" : 0, "y" : 0 };
	if (self.pageYOffset) {
		retval.x = self.pageXOffset;
		retval.y = self.pageYOffset;
	} else if (document.documentElement && document.documentElement.scrollTop) {
		retval.x = document.documentElement.scrollLeft;
		retval.y = document.documentElement.scrollTop;
	} else if (document.body) {
		retval.x = document.body.scrollLeft;
		retval.y = document.body.scrollTop;
	}
	return retval;
}

function getElementOffset(elem) {
	var left = 0;
	var top = 0;
	var height = elem.offsetHeight;
	var width = elem.offsetWidth;
	if(elem.offsetParent && elem.style.position != "absolute") {
		do {
			
			left += elem.offsetLeft;
			top += elem.offsetTop;
			if(elem.tagName == "BODY") { break; }
			
		} while (elem = elem.offsetParent);
	}
	return { "offsetLeft" : left, "offsetTop" : top, "offsetHeight" : height, "offsetWidth" : width };
}